import { ResolveFn, RejectFn } from '../types/index';
interface Interceptor<T> {
    resolve: ResolveFn<T>;
    reject?: RejectFn;
}
export default class InterceptorManager<T> {
    private interceptors;
    constructor();
    use(resolve: ResolveFn<T>, reject?: RejectFn): number;
    eject(id: number): void;
    forEach(fn: (interceptor: Interceptor<T>) => void): void;
}
export {};
